importPackage(Packages.jp.ngt.ngtlib.util);
importPackage(Packages.jp.ngt.rtm.sound);
importPackage(Packages.jp.ngt.ngtlib.io);

function onUpdate(su) {
    onUpdate_RSM2(su);
}

//ここから下のプログラムをコピペしてonUpdate(su)にonUpdate_RSM2(su);を記述することで別のスクリプトに移植できます。
//##### 定数 #####

//音量フェードの時間の長さを設定します 単位:tick
var PowerFadeTime = 10;

//音量フェードの開始時間を遅らせます 単位:tick
var PowerFadeDelay = 0;

//トンネル走行音のフェードの時間の長さを設定します 単位:tick
var TunnelFadeTime = 10;

//##### データ #####
var SoundTrackData = [{"pitch":[[0,1],[10,1]],"volume":[[0,0],[0.3,0.5],[6.2,1],[6.5,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"305_motor1.ogg"},{"pitch":[[0,1],[16,1]],"volume":[[6,0],[6.3,0.7],[8,1],[15,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"305_motor2.ogg"},{"pitch":[[0,1],[20,1]],"volume":[[7,0],[13.5,1],[18,1],[18.3,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"305_motor3.ogg"},{"pitch":[[4,0.5],[18.5,1.11]],"volume":[[4,0],[10.5,0.7],[18.5,0.7],[18.7,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"305_motor4.ogg"},{"pitch":[[17,0.83],[30,1.25]],"volume":[[18,0],[18.3,1],[25,1],[30,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"305_motor5.ogg"},{"pitch":[[20,0.7],[40,1.15]],"volume":[[23,0],[28,1],[30,1],[36,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"305_motor6.ogg"},{"pitch":[[27,0.75],[46,1.15]],"volume":[[28,0],[34,1],[36,1],[41,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"305_motor7.ogg"},{"pitch":[[33,0.83],[50,1.13]],"volume":[[33,0],[38,1],[40,1],[45,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"305_motor8.ogg"},{"pitch":[[35,0.78],[55,1.1]],"volume":[[37,0],[45,1],[48,1],[55,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"305_motor9.ogg"},{"pitch":[[42,0.75],[65,1.15]],"volume":[[42,0],[50,1],[58,1],[65,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"305_motor10.ogg"},{"pitch":[[55,0.82],[115,1.5]],"volume":[[56,0],[62,0.7],[80,0.7],[110,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"305_motor11.ogg"},{"pitch":[[65,0.9],[135,1.4]],"volume":[[65,0],[75,0.7],[130,0.7],[135,0]],"isMute":false,"isNotchPower":true,"isNotchOff":false,"isNotchBrake":true,"isFadeMixer":true,"isTunnelFade":null,"fileName":"305_motor13.ogg"},{"pitch":[[45,0.9],[105,1.5]],"volume":[[45,0],[55,0.3],[90,0.3],[100,0]],"isMute":false,"isNotchPower":true,"isNotchOff":true,"isNotchBrake":true,"isFadeMixer":false,"isTunnelFade":null,"fileName":"305_motor15.ogg"},{"pitch":[[80,0.85],[135,1.3]],"volume":[[80,0],[90,0.3],[130,0.3],[135,0]],"isMute":false,"isNotchPower":true,"isNotchOff":true,"isNotchBrake":true,"isFadeMixer":false,"isTunnelFade":null,"fileName":"305_motor17.ogg"},{"pitch":[[15,0.5],[30,1],[60,2]],"volume":[[0,0],[5,0.5],[35,0.5],[45,0]],"isMute":false,"isNotchPower":true,"isNotchOff":true,"isNotchBrake":true,"isFadeMixer":false,"isTunnelFade":null,"fileName":"305_Run30km2.ogg"},{"pitch":[[30,0.5],[60,1],[90,1.5]],"volume":[[35,0],[45,0.5],[70,0.5],[80,0]],"isMute":false,"isNotchPower":true,"isNotchOff":true,"isNotchBrake":true,"isFadeMixer":false,"isTunnelFade":false,"fileName":"305_Run60km2.ogg"},{"pitch":[[30,0.5],[60,1],[90,1.5]],"volume":[[35,0],[45,0.5],[75,0.5],[85,0]],"isMute":false,"isNotchPower":true,"isNotchOff":true,"isNotchBrake":true,"isFadeMixer":false,"isTunnelFade":true,"fileName":"305_Run60kmT3.ogg"},{"pitch":[[60,0.5],[120,1],[180,1.5]],"volume":[[75,0],[85,0.5],[135,0.5],[145,0]],"isMute":false,"isNotchPower":true,"isNotchOff":true,"isNotchBrake":true,"isFadeMixer":false,"isTunnelFade":false,"fileName":"305_Run120km2.ogg"},{"pitch":[[60,0.5],[120,1],[180,1.5]],"volume":[[75,0],[85,0.5],[135,0.5],[145,0]],"isMute":false,"isNotchPower":true,"isNotchOff":true,"isNotchBrake":true,"isFadeMixer":false,"isTunnelFade":true,"fileName":"305_Run120kmT.ogg"}];
var SoundEffectData = {"305_motor0.ogg":{"fileName":"305_motor0.ogg"},"brakeHigh":{"fileName":"305_brakerelease2.ogg"},"brakeLow":{"fileName":"305_brakerelease3.ogg"},"brakeOff":{"fileName":"305_brakerelease1.ogg"}};
var SoundData = {"305_motor1.ogg":["sound_305","305pmsm.305_motor1"],"305_motor2.ogg":["sound_305","305pmsm.305_motor2"],"305_motor3.ogg":["sound_305","305pmsm.305_motor3"],"305_motor4.ogg":["sound_305","305pmsm.305_motor4"],"305_motor5.ogg":["sound_305","305pmsm.305_motor5"],"305_motor6.ogg":["sound_305","305pmsm.305_motor6"],"305_motor7.ogg":["sound_305","305pmsm.305_motor7"],"305_motor8.ogg":["sound_305","305pmsm.305_motor8"],"305_motor9.ogg":["sound_305","305pmsm.305_motor9"],"305_motor10.ogg":["sound_305","305pmsm.305_motor10"],"305_motor11.ogg":["sound_305","305pmsm.305_motor11"],"305_motor13.ogg":["sound_305","305pmsm.305_motor13"],"305_motor15.ogg":["sound_305","305pmsm.305_motor15"],"305_motor17.ogg":["sound_305","305pmsm.305_motor17"],"305_Run30km2.ogg":["sound_305","305pmsm.305_Run30km2"],"305_Run60km2.ogg":["sound_305","305pmsm.305_Run60km2"],"305_Run60kmT3.ogg":["sound_305","305pmsm.305_Run60kmT3"],"305_Run120km2.ogg":["sound_305","305pmsm.305_Run120km2"],"305_Run120kmT.ogg":["sound_305","305pmsm.305_Run120kmT"],"305_motor0.ogg":["sound_305","305pmsm.305_motor0"],"305_brakerelease2.ogg":["sound_305","305pmsm.305_brakerelease2"],"305_brakerelease3.ogg":["sound_305","305pmsm.305_brakerelease3"],"305_brakerelease1.ogg":["sound_305","305pmsm.305_brakerelease1"]};
//##### データ #####

//##### onUpdate #####
function onUpdate_RSM2(su) {
    var entity = su.getEntity();
    var dataMap = entity.getResourceState().getDataMap();
    var speed = su.getSpeed();
    var notch = su.getNotch();
    //powerFade
    var powerFade = dataMap.getInt("powerFade");
    var powerFadeDelayTime = dataMap.getInt("powerFadeDelayTime");
    if (notch === 0) powerFadeDelayTime = Math.min(powerFadeDelayTime + 1, PowerFadeDelay);
    else if (speed > 0) powerFadeDelayTime = Math.max(powerFadeDelayTime - 1, 0);
    if (notch > 0 && powerFadeDelayTime === 0) powerFade = Math.min(powerFade + 1, PowerFadeTime);
    else if (notch < 0 && powerFadeDelayTime === 0) powerFade = Math.max(powerFade - 1, -PowerFadeTime);
    else if (powerFadeDelayTime === PowerFadeDelay) powerFade += powerFade < 0 ? 1 : powerFade > 0 ? -1 : 0;
    dataMap.setInt("powerFadeDelayTime", powerFadeDelayTime, 0);
    dataMap.setInt("powerFade", powerFade, 0);
    powerFade = powerFade / PowerFadeTime;
    //tunnelFade
    var isTunnel = su.inTunnel();
    var tunnelFade = dataMap.getInt("tunnelFade");
    if (isTunnel) tunnelFade = Math.min(tunnelFade + 1, TunnelFadeTime);
    else tunnelFade = Math.max(tunnelFade - 1, 0);
    dataMap.setInt("tunnelFade", tunnelFade, 0);
    tunnelFade = tunnelFade / TunnelFadeTime;
    //SoundTrack
    SoundTrackData.forEach(function (trackData) {
        var soundName = trackData.fileName;
        var customPitch = 1;
        var customVolume = 1;
        /* 指定の音源でpitchとvolumeを乗算でカスタムすることができます
        例)
        if (soundName === "run_mo0.ogg") {//soundNameはRSM2での音源の表示名に対応します(拡張子付きファイル名)
            customPitch = 1.0;//ノッチに対して変化を加えるなど
            customVolume = 1.0;
        }
        */
        var sound = new SoundState(su, trackData);
        sound.play(speed, notch, powerFade, tunnelFade, customPitch, customVolume);
    });
    //SoundEffect
    var se = {};
    Object.keys(SoundEffectData).forEach(function (key) {
        var trackData = SoundEffectData[key];
        se[key] = new SoundState(su, trackData);
    });
    //Compressor
    var isCPActive = su.isComplessorActive();
    if (se["cpStart"]) se["cpStart"].playSE(isCPActive, false);
    if (se["cpLoop"]) se["cpLoop"].playSE(isCPActive, true);
    if (se["cpEnd"]) se["cpEnd"].playSE(!isCPActive, false);
    //Brake release
    var prevNotch = dataMap.getInt("prevNotch");
    dataMap.setInt("prevNotch", notch, 0);
    var isPlayBrakeH = prevNotch < notch && prevNotch === -8;
    var isPlayBrakeL = prevNotch <= 0 && prevNotch < notch && prevNotch < -1;
    var isPlayBrakeN = prevNotch < 0 && prevNotch < notch && notch >= 0;
    if (speed < 1) {
        if (se["brakeLow"]) se["brakeLow"].playSEOnce(isPlayBrakeL);
        if (se["brakeOff"]) se["brakeOff"].playSEOnce(isPlayBrakeN);
    }
    if (se["brakeHigh"]) se["brakeHigh"].playSEOnce(isPlayBrakeH);
}

//##### 関数 #####
var SoundState = function (su, trackData) {
    this.su = su;
    this.pitch = trackData.pitch || null;
    this.volume = trackData.volume || null;
    this.isMute = trackData.isMute || null;
    this.isNotchPower = trackData.isNotchPower || null;
    this.isNotchOff = trackData.isNotchOff || null;
    this.isNotchBrake = trackData.isNotchBrake || null;
    this.isFadeMixer = trackData.isFadeMixer || null;
    this.isTunnelFade = trackData.isTunnelFade; // null / true / false
    if (this.isTunnelFade === undefined) this.isTunnelFade = null;
    this.fileName = trackData.fileName;
    this.soundDmain = null;
    this.soundName = null;
    if (SoundData[this.fileName]) {
        this.soundDmain = SoundData[this.fileName][0];
        this.soundName = SoundData[this.fileName][1];
    }
};
SoundState.prototype = {
    getPitch: function (speed) {
        var pitch = interpolate(this.pitch, speed);
        return Math.min(Math.max(pitch, 0.5), 2.0);
    },
    getVolume: function (speed) {
        var volume = interpolate(this.volume, speed);
        if (speed > this.volume[this.volume.length - 1][0]) return 0;
        return Math.min(Math.max(volume, 0), 1.0);
    },
    getMixerVolume: function (notch, volumeFade, tunnelFade) {
        var volume = 1;
        var isNotchPower = this.isNotchPower;
        var isNotchOff = this.isNotchOff;
        var isNotchBrake = this.isNotchBrake;
        //Volume fade
        if (this.isFadeMixer && (isNotchOff !== isNotchPower || isNotchOff !== isNotchBrake)) {
            var notchFade = Number(volumeFade);
            var notchFadeF = Number(1 - Math.abs(notchFade));
            volume *= Math.max(
                Number(isNotchPower && notchFade > 0),
                Number(isNotchOff && notchFadeF > 0),
                Number(isNotchBrake && notchFade < 0)
            );
            volume *= isNotchOff ? Number(notchFadeF) : Number(Math.abs(notchFade));
        }
        else {
            volume *= Math.max(
                Number(isNotchPower && notch > 0),
                Number(isNotchOff && notch === 0),
                Number(isNotchBrake && notch < 0)
            );
        }
        //Tunnnel fade
        if (this.isTunnelFade !== null) {
            if (this.isTunnelFade === true) volume *= Number(tunnelFade);
            else volume *= Number(1 - tunnelFade);
        }
        volume *= Number(!this.isMute);
        return volume;
    },
    play: function (speed, notch, volumeFade, tunnelFade, customPitch, customVolume) {
        if (!this.soundDmain || !this.soundName) return;
        var pitch = this.getPitch(speed) * customPitch;
        var volume = this.getVolume(speed) * this.getMixerVolume(notch, volumeFade, tunnelFade) * customVolume;
        if (volume > 0) {
            this.su.playSound(this.soundDmain, this.soundName, volume, pitch, true);
        }
        else {
            this.su.stopSound(this.soundDmain, this.soundName);
        }
    },
    //条件分岐がtrueのときに再生する(falseで停止)
    playSE: function (condition, isLoop) {
        if (condition) this.su.playSound(this.soundDmain, this.soundName, 1, 1, isLoop);
        else this.su.stopSound(this.soundDmain, this.soundName);
    },
    //1tickだけ再生処理を実行するSEに使用する
    playSEOnce: function (condition) {
        if (condition) {
            this.su.stopSound(this.soundDmain, this.soundName);
            this.su.playSound(this.soundDmain, this.soundName, 1, 1, false);
        }
    }
};
function interpolate(valueList, speed) {
    if (valueList.length === 1) return 0;
    if (speed < valueList[0][0]) return valueList[0][1];
    for (var i = 0; i < valueList.length - 1; i++) {
        var currentSpeed = valueList[i][0];
        var currentValue = valueList[i][1];
        var nextSpeed = valueList[i + 1][0];
        var nextValue = valueList[i + 1][1];
        if (speed >= currentSpeed && speed <= nextSpeed) {
            var ratio = (speed - currentSpeed) / (nextSpeed - currentSpeed);
            return currentValue + (nextValue - currentValue) * ratio;
        }
    }
    return valueList[valueList.length - 1][1];
}